import 'package:adobe_xd/pinned.dart';
import 'package:firebase_core/firebase_core.dart';
import 'package:flutter/material.dart';

import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:global_configuration/global_configuration.dart';
import 'package:minilikewallet/home/button_action/button_action.dart';
import 'package:minilikewallet/home/index.dart';

import 'package:minilikewallet/otp_page/component/otp_page_component.dart';
import 'package:minilikewallet/otp_page/otp_page.dart';
import 'package:minilikewallet/provider/home_provider/check_tx_provider.dart';
import 'package:minilikewallet/provider/home_provider/counter.dart';
import 'package:minilikewallet/provider/home_provider/first_page_provider/first_page_provider.dart';
import 'package:minilikewallet/provider/home_provider/home_provider.dart';
import 'package:minilikewallet/provider/home_provider/index_provider/index_provider.dart';
import 'package:minilikewallet/provider/home_provider/loading_provider/loading_provider.dart';
import 'package:minilikewallet/provider/home_provider/lock_all_provider/lock_all_provider.dart';
import 'package:minilikewallet/provider/home_provider/otp_provider/otp_provider.dart';
import 'package:minilikewallet/provider/home_provider/receive_provider/receive_provider.dart';
import 'package:minilikewallet/provider/home_provider/send_provider/send_provider.dart';
import 'package:minilikewallet/receive/receive.dart';
import 'package:minilikewallet/send/send.dart';
import 'package:minilikewallet/send/send_confirm.dart';
import 'package:minilikewallet/send/send_receipt.dart';
import 'package:minilikewallet/theme/image.dart';
import 'package:minilikewallet/theme/widget.dart';
import 'package:provider/provider.dart';

void runMain() async {
  print('WTF!');
  await Firebase.initializeApp();
  WidgetsFlutterBinding.ensureInitialized();
  // try {
  //   await GlobalConfiguration()
  //       .loadFromUrl("https://new.likepoint.io/configAPI");
  // } catch (e) {
  //   print(e);
  //   // something went wrong while fetching the config from the url ... do something
  // }
}

class FirstPage extends StatelessWidget {
  FirstPage({this.phone});
  final String phone;

  @override
  Widget build(BuildContext context) {
    runMain();
    return MultiProvider(
      providers: [
        ChangeNotifierProvider.value(value: Counter()),
        ChangeNotifierProvider.value(value: HomeProvider()),
        ChangeNotifierProvider.value(value: SendProvider()),
        ChangeNotifierProvider.value(value: LockAllProvider()),
        ChangeNotifierProvider.value(value: OTPProvider()),
        ChangeNotifierProvider.value(value: LoadingProvider()),
        ChangeNotifierProvider.value(value: IndexProvider()),
        ChangeNotifierProvider.value(value: ReceiveProvider()),
        ChangeNotifierProvider.value(value: CheckTXProvider()),
        ChangeNotifierProvider.value(value: FirstPageProvider()),
      ],
      child: MyHomePage(phone: phone),
    );
  }
}

enum providerSMS { Firebase, Twilio, Nexmo, Email }

class MyHomePage extends StatefulWidget {
  MyHomePage({this.phone});
  final String phone;

  @override
  _MyHomePage createState() => _MyHomePage();
}

class _MyHomePage extends State<MyHomePage> {
  _MyHomePage({this.phone});
  final String phone;
  HomeProvider _homeProvider;
  OTPProvider _otpProvider;
  LoadingProvider _loadingProvider;
  IndexProvider _indexProvider;
  FirstPageProvider _firstPageProvider;
  providerSMS roundSMS = providerSMS.Twilio;

  @override
  void didChangeDependencies() async {
    super.didChangeDependencies();
    _homeProvider = Provider.of<HomeProvider>(context);
    _otpProvider = Provider.of<OTPProvider>(context);
    _loadingProvider = Provider.of<LoadingProvider>(context);
    _indexProvider = Provider.of<IndexProvider>(context);
    _firstPageProvider = Provider.of<FirstPageProvider>(context);

    // bool login = await _otpProvider.checkLogin();
    // _firstPageProvider.setStatus(status: true);
    // _loadingProvider.setStatus(status: true);
    // if (login) {
    //   _homeProvider.setMenu(status: true);
    //   _loadingProvider.setStatus(status: false);
    // }
  }

  @override
  void initState() {
    // TODO: implement initState
    super.initState();
    setInitStart();
  }

  setInitStart() async {
    await context
        .read<IndexProvider>()
        .setGetLogin(status: await context.read<OTPProvider>().checkLogin());
  }

  @override
  Widget build(BuildContext context) {
    ScreenUtil.init(context,
        designSize: Size(1080, 2340), allowFontScaling: false);
    return Scaffold(
      backgroundColor: Colors.transparent,
      body: Container(
        width: 1080.0.w,
        color: Colors.transparent,
        child: Stack(
          children: <Widget>[
            // _firstPageProvider.getLoading
            //     ? Container()
            //     : Positioned(
            //         top: -174.h, child: OTPPageComponent.otpBackground()),
            _indexProvider.getLogin
                ? IndexScreen()
                : Container(
                    width: 1080.0.w,
                    height: 1000.0.h,
                    decoration: BoxDecoration(
                      borderRadius: BorderRadius.only(
                        bottomLeft: Radius.circular(103.0.h),
                        bottomRight: Radius.circular(103.0.h),
                      ),
                      color: const Color(0xff111322),
                    ),
                    child: Column(
                      children: [
                        SizedBox(height: 100.9.h),
                        Image.asset(
                          ImageTheme.likeWallet,
                          height: 250.h,
                          package: 'minilikewallet',
                        ),
                        Expanded(
                          child: button(),
                        ),
                        Padding(
                          padding: EdgeInsets.all(4.0.h),
                          child: InkWell(
                              onTap: () async {
                                Navigator.of(context).pop();
                              },
                              child: Container(
                                  height: 30.h,
                                  width: 60.w,
                                  margin: EdgeInsets.all(20.w),
                                  padding: EdgeInsets.symmetric(vertical: 10.h),
                                  child: ButtonAction.closeMenuWhite())),
                        ),
                        SizedBox(height: 50.9.h),
                      ],
                    ),
                  ),
            _homeProvider.getSend ? SendScreen() : Container(),
            _homeProvider.getSendConfirm
                ? SendConfirmScreen(
                    phone: widget.phone,
                  )
                : Container(),
            _homeProvider.getSendReceipt ? SendReceiptScreen() : Container(),
            _homeProvider.getReceive ? ReceiveScreen() : Container(),
            _homeProvider.getOTP
                ? OTPPageScreen(
                    phone: widget.phone,
                  )
                : Container(),
            // _firstPageProvider.getLoading
            //     ? Container()
            //     :
          ],
        ),
      ),
    );
  }

  Widget button() => Center(
        child: SizedBox(
          height: 120.0.h,
          width: 500.0.w,
          child: Stack(
            alignment: Alignment.center,
            children: <Widget>[
              Pinned.fromSize(
                bounds: Rect.fromLTWH(0.0, 0.0, 227.0.w, 68.0.h),
                size: Size(227.0.w, 68.0.h),
                pinLeft: true,
                pinRight: true,
                pinTop: true,
                pinBottom: true,
                child: Container(
                  decoration: BoxDecoration(
                    borderRadius: BorderRadius.circular(20.0.h),
                    color: Color(0xff1e9fa7),
                  ),
                ),
              ),
              InkWell(
                onTap: () => actionLogin(),
                child: Text(
                  _indexProvider.getLogin ? 'ไปยังกระเป๋า' : 'เข้าสู่ระบบ',
                  style: TextStyle(
                    fontFamily: 'Proxima Nova',
                    fontSize: 49.h,
                    fontWeight: FontWeight.bold,
                    color: Colors.white,
                    letterSpacing: 0.99,
                  ),
                  textAlign: TextAlign.center,
                ),
              ),
            ],
          ),
        ),
      );

  void actionLogin() async {
    bool login = await _otpProvider.checkLogin();
    _firstPageProvider.setStatus(status: true);
    _loadingProvider.setStatus(status: true);
    if (login) {
      _homeProvider.setMenu(status: true);
      await _indexProvider.loadBalance();
      _loadingProvider.setStatus(status: false);
    } else {
      _homeProvider.setOTP(status: true);
      await _otpProvider.setNumberPhone(phone: widget.phone);
      final res = await _otpProvider.checkExistUser(
          phoneNumber: _otpProvider.getNumberPhone);
      if (res) {
        final res = await _otpProvider.sendCodeToPhoneNumber(
            phoneNumber: _otpProvider.getNumberPhone);
        if (res) {
          _loadingProvider.setStatus(status: false);
        } else {
          _homeProvider.setOTP(status: false);
          Navigator.of(context).pop();
          WidgetTheme.showShortToastRed('เกิดข้อผิดพลาด');
        }
      } else {
        Navigator.of(context).pop();
        WidgetTheme.showShortToastRed('ไม่พบเบอร์ในระบบ');
      }
    }
  }
}
