import 'dart:io';

import 'package:flutter/gestures.dart';
import 'package:flutter/material.dart';
import 'package:flutter_svg/flutter_svg.dart';
import 'package:minilikewallet/theme/image.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';

class HomeComponent {
  HomeComponent._();
  static Widget nameWallet({String name}) => Row(
        children: [
          Image.asset(
            ImageTheme.iconNameWallet,
            height: 72.07.h,
            width: 73.11.w,
            package: 'minilikewallet',
          ),
          SizedBox(width: 30.w),
          Text(
            name,
            style: TextStyle(
              fontFamily: 'Proxima Nova',
              fontSize: 39.h,
              color: const Color(0xff000000),
              letterSpacing: 1.17.w,
            ),
            textAlign: TextAlign.left,
          ),
        ],
      );

  static Widget openLikeWallet() => Stack(
        alignment: Alignment.center,
        children: [
          SvgPicture.string(
            '<svg viewBox="814.0 193.3 267.3 96.0" ><defs><filter id="shadow"><feDropShadow dx="0" dy="5" stdDeviation="12"/></filter><linearGradient id="gradient" x1="1.0" y1="0.5" x2="0.0" y2="0.5"><stop offset="0.0" stop-color="#2196ffff" stop-opacity="0.13" /><stop offset="0.658433" stop-color="#c496ffff" stop-opacity="0.77" /><stop offset="1.0" stop-color="#ff96ffff"  /></linearGradient></defs><path transform="translate(814.0, 193.32)" d="M 48 0 L 267.265625 0 L 267.265625 96 L 48 96 C 21.49032974243164 96 0 74.50967407226563 0 48 C 0 21.49032974243164 21.49032974243164 0 48 0 Z" fill="url(#gradient)" stroke="none" stroke-width="3" stroke-miterlimit="4" stroke-linecap="butt" filter="url(#shadow)"/></svg>',
            allowDrawingOutsideViewBox: true,
            fit: BoxFit.fill,
            height: 96.h,
            width: 267.27.w,
          ),
          RichText(
            text: TextSpan(
                text: 'like',
                style: TextStyle(
                    color: Colors.black,
                    fontFamily: '',
                    fontWeight: FontWeight.bold,
                    fontSize: 25.64.h),
                children: <TextSpan>[
                  TextSpan(
                      text: 'Wallet',
                      style: TextStyle(
                          color: Colors.black,
                          fontFamily: '',
                          fontWeight: FontWeight.normal,
                          fontSize: 25.64.h),
                      recognizer: TapGestureRecognizer()
                        ..onTap = () {
                          // navigate to desired screen
                        })
                ]),
          ),
        ],
      );
}
