import 'dart:async';
import 'dart:io';

import 'package:adobe_xd/adobe_xd.dart';
import 'package:cloud_firestore/cloud_firestore.dart';
import 'package:device_apps/device_apps.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/gestures.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:flutter_appavailability/flutter_appavailability.dart';
import 'dart:ui' as ui;
import 'package:intl/intl.dart' as formatIntl;

import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:flutter_svg/flutter_svg.dart';
import 'package:launch_review/launch_review.dart';
import 'package:minilikewallet/home/button_action/button_action.dart';
import 'package:minilikewallet/home/home_component/home_component.dart';
import 'package:minilikewallet/library/address_service.dart';
import 'package:minilikewallet/library/configuration_service.dart';
import 'package:minilikewallet/library/ethcontract.dart';
import 'package:minilikewallet/lock_all/lock_all.dart';
import 'package:minilikewallet/middleware/check_auth.dart';
import 'package:minilikewallet/middleware/open_url.dart';
import 'package:minilikewallet/provider/home_provider/home_provider.dart';
import 'package:minilikewallet/provider/home_provider/index_provider/index_provider.dart';
import 'package:minilikewallet/provider/home_provider/loading_provider/loading_provider.dart';
import 'package:minilikewallet/provider/home_provider/send_provider/send_provider.dart';
import 'package:minilikewallet/theme/color.dart';
import 'package:minilikewallet/theme/image.dart';
import 'package:minilikewallet/theme/loading.dart';
import 'package:open_appstore/open_appstore.dart';
import 'package:provider/provider.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'package:url_launcher/url_launcher.dart';
import 'package:web3dart/web3dart.dart';

class IndexScreen extends StatefulWidget {
  @override
  _IndexScreen createState() => _IndexScreen();
}

class _IndexScreen extends State<IndexScreen>
    with SingleTickerProviderStateMixin {
  HomeProvider _getLikeWallet;
  IndexProvider _indexProvider;
  LoadingProvider _loadingProvider;
  SendProvider _sendProvider;
  OpenUrl openUrl;
  double dept = 0.0;

  final f = new formatIntl.NumberFormat("###,###.##");

  @override
  void initState() {
    // TODO: implement initState
    super.initState();
    openUrl = IOpenUrl();
    setInitFirst();
  }

  @override
  void didChangeDependencies() async {
    super.didChangeDependencies();
    _indexProvider = Provider.of<IndexProvider>(context);
    _getLikeWallet = Provider.of<HomeProvider>(context);
    _loadingProvider = Provider.of<LoadingProvider>(context);
    _sendProvider = Provider.of<SendProvider>(context);
  }

  setInitFirst() async {
    SharedPreferences pref = await SharedPreferences.getInstance();
    _sendProvider.getNameFROM(address: pref.getString('addressETH'));
    await Future.delayed(Duration(seconds: 1));
    await _indexProvider.loadBalance();
    // fiat = pref.getString('currency') ?? 'none';
    // print('fiat : ' + fiat);

    //     .then((address) {
    //   print(address.toString());
    //   configETH.setAddress(address.toString());
    //   eth.getBalance(address: address.hex).then((balance) {
    //
    //   });
    // });
  }

  // Future reloadBalance(address, fiat) async {
  //   print(address);
  //   eth.getBalance(address: address).then((balance) async {
  //     print("balance" + balance.toString());
  //
  //     // eth.getBalanceLock(address: address).then((balanceLock) async {
  //     //   print("balanceLock" + balanceLock.toString());
  //     //   // await eth.getLoanV2(address: address).then((loan) {
  //     //   //   // if (loan[11].toString() == "1") {
  //     //   //   //   dept = double.parse(
  //     //   //   //       EtherAmount.inWei(loan[6] as BigInt).getInEther.toString());
  //     //   //   //   print("เงินต้น" +
  //     //   //   //       EtherAmount.inWei(loan[6] as BigInt).getInEther.toString());
  //     //   //   // }
  //     //   // });
  //     //
  //     //
  //     // });
  //   });
  // totalBalance = balance + balanceLock;
  // balanceLIKELock = balanceLock;
  // print(balanceShow);
  // locked_balance = f.format(balanceLock + dept).toString();
  // double total = context.read(amount).state +
  //     double.parse(locked_balance.replaceAll(',', ''));
  // streamTotalBalance.sink.add(f.format(total).toString());
  // streamBalanceLock.sink.add(balanceLIKELock);
  // streamBalanceLocked.sink.add(locked_balance);
//      streamController.sink.add(amount.read(context).state);

  // context.read(amount).state = balance;
//      amount = balance;
//         if (numberReload == 0) {
//           print(numberReload);
//           streamCurrency(total);
//         } else if (numberReload == 1) {
//           print(numberReload);
//           streamCurrency(double.parse(locked_balance.replaceAll(',', '')));
//         } else if (numberReload == 2) {
//           print(numberReload);
//           streamCurrency(balance);
//         }
//   }

  @override
  Widget build(BuildContext context) {
    ScreenUtil.init(context,
        designSize: Size(1080, 2340), allowFontScaling: false);
    return Scaffold(
      backgroundColor: Colors.black26,
      body: Container(
        color: Colors.transparent,
        height: 1247.0.h,
        child: Stack(
          children: [
            background(),
            _loadingProvider.getLoading
                ? Center(child: Loading.showLoading(context: context))
                : Container(
                    width: MediaQuery.of(context).size.width,
                    child: Column(
                      children: [
                        SizedBox(height: 140.h),
                        InkWell(
                          onTap: () => openUrl.launchURL(),
                          child: Container(
                            height: 101.56.h,
                            margin: EdgeInsets.only(left: 75.w),
                            child: Row(
                              mainAxisAlignment: MainAxisAlignment.spaceBetween,
                              children: [
                                HomeComponent.nameWallet(
                                    name: _sendProvider.nameFOMR),
                                HomeComponent.openLikeWallet()
                              ],
                            ),
                          ),
                        ),
                        //------------- ส่วนหลักหน้าเเรก ----------//
                        _getLikeWallet.getLockAll
                            ? LockAllScreen()
                            : bodyHome(),
                        Expanded(child: Container()),
                        SizedBox(
                          width: 950.0.w,
                          height: 99.0.h,
                          child: Text(
                            'Hi! I am mini app with limited function.\nPlease get into LikeWallet for more usage. ',
                            style: TextStyle(
                              fontFamily: 'Proxima Nova',
                              fontSize: 30.h,
                              color: const Color(0xcc000000),
                              letterSpacing: 0.8999999999999999,
                              height: 1.3,
                            ),
                            textHeightBehavior: TextHeightBehavior(
                                applyHeightToFirstAscent: false),
                            textAlign: TextAlign.center,
                          ),
                        ),
                        InkWell(
                            onTap: () async {
                              _getLikeWallet.setMenu(status: false);
                              _getLikeWallet.setLockAll(status: false);

                              Navigator.of(context).pop();
                            },
                            child: Container(
                                height: 30.h,
                                width: 60.w,
                                margin: EdgeInsets.all(10.w),
                                padding: EdgeInsets.symmetric(vertical: 10.h),
                                child: ButtonAction.closeMenu())),

                        SizedBox(height: 14.9.h),
                      ],
                    ),
                  )
          ],
        ),
      ),
    );
  }

  Widget bodyHome() => Column(
        children: [
          SizedBox(height: 114.3.h),
          Row(
            mainAxisAlignment: MainAxisAlignment.spaceBetween,
            children: [
              SizedBox(width: 120.w),
              iconLike(),
              Expanded(child: Container()),
              Column(
                children: [
                  Text(
                    'Available Likepoint',
                    style: TextStyle(
                      fontFamily: 'Proxima Nova',
                      fontSize: 30.h,
                      color: const Color(0x66ffffff),
                      letterSpacing: 3,
                      height: 1.9,
                    ),
                    textHeightBehavior:
                        TextHeightBehavior(applyHeightToFirstAscent: false),
                    textAlign: TextAlign.left,
                  ),
                  SizedBox(height: 23.8.h),
                  // Text(
                  //   '2,678,000',
                  //   style: TextStyle(
                  //     fontFamily: 'Roboto',
                  //     fontSize: 88.h,
                  //     color: const Color(0xffffffff),
                  //   ),
                  //   textAlign: TextAlign.center,
                  // ),
                  // StreamBuilder(
                  //     stream: _indexProvider.streamController.stream,
                  //     initialData: 0,
                  //     builder:
                  //         (context, snapshot) {
                  //       return

                  Text(
                    f.format(_indexProvider.getBalance).toString(),
                    textAlign: TextAlign.left,
                    style: TextStyle(
                        fontFamily: 'Roboto',
                        color: Colors.white,
                        height: 2.7.h,
                        fontSize: 66.h),
                  ),

                  // );
                  // }),
                  SizedBox(height: 23.8.h),
                  // StreamBuilder(
                  //     stream: _indexProvider.streamCurrencyAmount.stream,
                  //     initialData: '0',
                  //     builder: (context, snapshot) {
                  //       return
                  Text(
                    '= THB ' +
                        f.format(_indexProvider.getBalance / 100).toString(),
                    style: TextStyle(
                      fontFamily: 'Roboto',
                      fontSize: 36.h,
                      color: const Color(0x4dffffff),
                      letterSpacing: 1.8,
                    ),
                    textAlign: TextAlign.right,
                  ),
                  // }),
                ],
              ),
              Expanded(child: Container()),
              InkWell(
                  onTap: () {
                    _indexProvider.setBalance(value: 0.0);
                    _indexProvider.loadBalance();
                  },
                  child: Container(
                    margin: EdgeInsets.all(10.w),
                    child: Icon(
                      Icons.refresh,
                      color: _indexProvider.statusGetBalance
                          ? Colors.grey.withOpacity(0.5)
                          : Colors.white,
                      size: 60.h,
                    ),
                  )),
              SizedBox(width: 120.w),
            ],
          ),
          SizedBox(height: 159.h),
          rowActionButton(),
        ],
      );

  Widget rowActionButton() => Row(
        mainAxisAlignment: MainAxisAlignment.spaceBetween,
        children: [
          SizedBox(width: 215.w),
          InkWell(
            onTap: () => _getLikeWallet.setSend(status: true),
            child: actionButton(ButtonAction.send(), ButtonAction.sendText()),
          ),
          InkWell(
              onTap: () {
                _getLikeWallet.setReceive(status: true);
                _getLikeWallet.setMenu(status: false);
              },
              child: actionButton(
                  ButtonAction.receive(), ButtonAction.receiveText())),
          InkWell(
            onTap: () => _getLikeWallet.setLockAll(status: true),
            child: actionButton(
                ButtonAction.lockAll(), ButtonAction.lockAllText()),
          ),
          SizedBox(width: 215.w),
          // ButtonAction.send(),
        ],
      );
  Widget actionButton(Widget widget, Text text) => Column(
        children: [
          Container(height: 125.0.h, width: 125.0.h, child: widget),
          SizedBox(height: 19.1.h),
          text
        ],
      );

  Widget background() => SizedBox(
        width: 1080.0.w,
        height: 1247.0.h,
        child: Stack(
          children: <Widget>[
            Pinned.fromSize(
              bounds: Rect.fromLTWH(0.0, 0.0, 1080.0.w, 627.0.h),
              size: Size(1080.0.w, 1247.0.h),
              pinLeft: true,
              pinRight: true,
              pinTop: true,
              fixedHeight: true,
              child: Container(
                decoration: BoxDecoration(
                  gradient: LinearGradient(
                    begin: Alignment(-1.0, 0.0),
                    end: Alignment(1.0, 0.0),
                    colors: [const Color(0xff00ebf0), const Color(0xff00b5c4)],
                    stops: [0.0, 1.0],
                  ),
                ),
              ),
            ),
            Pinned.fromSize(
              bounds: Rect.fromLTWH(0.0, 251.7.h, 1080.0.w, 995.3.h),
              size: Size(1080.0.w, 1247.0.h),
              pinLeft: true,
              pinRight: true,
              pinTop: true,
              pinBottom: true,
              child: Stack(
                children: <Widget>[
                  Pinned.fromSize(
                    bounds: Rect.fromLTWH(0.0, 324.3.h, 1080.0.w, 671.0.h),
                    size: Size(1080.0.w, 995.3.h),
                    pinLeft: true,
                    pinRight: true,
                    pinTop: true,
                    pinBottom: true,
                    child: ClipRect(
                      child: BackdropFilter(
                        filter:
                            ui.ImageFilter.blur(sigmaX: 50.0.w, sigmaY: 50.0.h),
                        child: Container(
                          decoration: BoxDecoration(
                            borderRadius: BorderRadius.only(
                              bottomLeft: Radius.circular(103.w),
                              bottomRight: Radius.circular(103.w),
                            ),
                            gradient: LinearGradient(
                              begin: Alignment(-1.0, 0.0),
                              end: Alignment(1.0, 0.0),
                              colors: [
                                const Color(0xe700ebf0),
                                const Color(0xe700b2c9)
                              ],
                              stops: [0.0, 1.0],
                            ),
                          ),
                        ),
                      ),
                    ),
                  ),
                  Pinned.fromSize(
                    bounds: Rect.fromLTWH(0.0, 321.8.h, 1080.0.w, 490.7.h),
                    size: Size(1080.0.w, 995.3.h),
                    pinLeft: true,
                    pinRight: true,
                    fixedHeight: true,
                    child: SvgPicture.string(
                      '<svg viewBox="0.0 573.4 1080.0 490.7" ><defs><filter id="shadow"><feDropShadow dx="0" dy="19" stdDeviation="45"/></filter></defs><path transform="translate(0.0, -273.85)" d="M 1080 847.29443359375 L 1080 1198 C 1080 1275.31982421875 1017.319885253906 1338 940 1338 L 140 1338 C 62.68013000488281 1338 0 1275.31982421875 0 1198 L 0 847.29443359375 L 1080 847.29443359375 Z" fill="#16192f" stroke="none" stroke-width="1" stroke-miterlimit="4" stroke-linecap="butt" filter="url(#shadow)"/></svg>',
                      allowDrawingOutsideViewBox: true,
                      fit: BoxFit.fill,
                    ),
                  ),
                  Pinned.fromSize(
                    bounds: Rect.fromLTWH(40.0.w, 0.0, 1000.0.w, 640.5.h),
                    size: Size(1080.0.w, 995.3.h),
                    pinLeft: true,
                    pinRight: true,
                    pinTop: true,
                    fixedHeight: true,
                    child: SvgPicture.string(
                      '<svg viewBox="40.0 251.7 1000.0 640.5" ><defs><linearGradient id="gradient" x1="0.5" y1="0.0" x2="0.5" y2="1.0"><stop offset="0.0" stop-color="#ff232e4a"  /><stop offset="1.0" stop-color="#ff16192f"  /></linearGradient></defs><path transform="translate(40.0, 251.68)" d="M 78.66274261474609 0 L 921.3373413085938 0 C 964.7815551757813 0 999.9999389648438 32.79358673095703 999.9999389648438 73.24652862548828 L 999.9999389648438 567.2597045898438 C 999.9999389648438 607.7127685546875 964.7815551757813 640.50634765625 921.3373413085938 640.50634765625 L 78.66274261474609 640.50634765625 C 35.21850967407227 640.50634765625 0 607.7127685546875 0 567.2597045898438 L 0 73.24652862548828 C 0 32.79358673095703 35.21850967407227 0 78.66274261474609 0 Z" fill="url(#gradient)" stroke="none" stroke-width="1" stroke-miterlimit="4" stroke-linecap="butt" /></svg>',
                      allowDrawingOutsideViewBox: true,
                      fit: BoxFit.fill,
                    ),
                  ),
                ],
              ),
            ),
          ],
        ),
      );
  Widget iconLike() => Image.asset(
        ImageTheme.iconLike,
        height: 84.37.h,
        width: 84.37.w,
        package: 'minilikewallet',
      );
}
