import 'dart:async';
import 'package:intl/intl.dart' as formatIntl;
import 'package:adobe_xd/adobe_xd.dart';
import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:flutter_svg/flutter_svg.dart';

class LockAllComponent {
  LockAllComponent._();

  static Widget textAmount({StreamController amount}) {
    final f = new formatIntl.NumberFormat("###,###.##");
    return StreamBuilder(
        stream: amount.stream,
        initialData: 0,
        builder: (context, snapshot) {
          return Text(
            f.format(snapshot.data).toString(),
            textAlign: TextAlign.center,
            style: TextStyle(
              fontFamily: 'Proxima Nova',
              fontSize: 39.h,
              color: const Color(0xffa989ff),
              letterSpacing: 1.9500000000000002,
            ),
          );
        });
  }

  // Text(
  //   amount.toString(),
  //   style: TextStyle(
  //     fontFamily: 'Proxima Nova',
  //     fontSize: 39.h,
  //     color: const Color(0xffa989ff),
  //     letterSpacing: 1.9500000000000002,
  //   ),
  //   textAlign: TextAlign.center,
  // );

  static Widget text({String text}) => Text(
        text.toString(),
        style: TextStyle(
          fontFamily: 'Proxima Nova',
          fontSize: 39.h,
          color: const Color(0xffFFFFFF),
          letterSpacing: 1.9500000000000002.w,
        ),
        textAlign: TextAlign.center,
      );

  static Widget buttonAction({String text}) => Container(
        width: 798.0.w,
        height: 118.0.h,
        child: Stack(
          alignment: Alignment.center,
          children: <Widget>[
            Pinned.fromSize(
              bounds: Rect.fromLTWH(0.0, 0.0, 798.0.w, 118.0.h),
              size: Size(798.0.w, 118.0.h),
              pinLeft: true,
              pinRight: true,
              pinTop: true,
              pinBottom: true,
              child: Stack(
                children: <Widget>[
                  Pinned.fromSize(
                    bounds: Rect.fromLTWH(0.0, 0.0, 798.0.w, 118.0.h),
                    size: Size(798.w, 118.0.h),
                    pinLeft: true,
                    pinRight: true,
                    pinTop: true,
                    pinBottom: true,
                    child: Stack(
                      alignment: Alignment.center,
                      children: <Widget>[
                        Pinned.fromSize(
                          bounds: Rect.fromLTWH(0.0, 0.0, 798.0.w, 118.0.h),
                          size: Size(798.0.w, 118.0.h),
                          pinLeft: true,
                          pinRight: true,
                          fixedHeight: true,
                          child: SvgPicture.string(
                            '<svg viewBox="0.0 0.0 798.0 118.0" ><defs><filter id="shadow"><feDropShadow dx="0" dy="24" stdDeviation="24"/></filter><linearGradient id="gradient" x1="0.047485" y1="0.5" x2="1.0" y2="0.5"><stop offset="0.0" stop-color="#ffb190fc"  /><stop offset="0.546798" stop-color="#ff7b75fd"  /><stop offset="1.0" stop-color="#ff5648fa"  /></linearGradient></defs><path  d="M 53.26018142700195 0 L 744.7398071289063 0 C 774.154541015625 0 798 26.41519927978516 798 59 C 798 91.58480072021484 774.154541015625 118 744.7398071289063 118 L 53.26018142700195 118 C 23.84539413452148 118 0 91.58480072021484 0 59 C 0 26.41519927978516 23.84539413452148 0 53.26018142700195 0 Z" fill="url(#gradient)" fill-opacity="1.0" stroke="none" stroke-width="1" stroke-opacity="1.0" stroke-miterlimit="4" stroke-linecap="butt" filter="url(#shadow)"/></svg>',
                            allowDrawingOutsideViewBox: true,
                            fit: BoxFit.fill,
                          ),
                        ),
                        Text(
                          text,
                          style: TextStyle(
                            fontFamily: 'Proxima Nova',
                            fontSize: 39.h,
                            color: const Color(0xffffffff),
                            letterSpacing: 1.9500000000000002,
                            fontWeight: FontWeight.w600,
                          ),
                          textAlign: TextAlign.center,
                        ),
                      ],
                    ),
                  ),
                ],
              ),
            ),
          ],
        ),
      );

  static Widget buttonLoadLock() => SizedBox(
        width: 118.0.h,
        height: 118.0.h,
        child: Stack(
          alignment: Alignment.center,
          children: <Widget>[
            Pinned.fromSize(
              bounds: Rect.fromLTWH(0.0, 0.0, 118.0.h, 118.0.h),
              size: Size(118.0.h, 118.0.h),
              pinLeft: true,
              pinRight: true,
              pinTop: true,
              pinBottom: true,
              child: Stack(
                children: <Widget>[
                  Pinned.fromSize(
                    bounds: Rect.fromLTWH(0.0, 0.0, 118.0.h, 118.0.h),
                    size: Size(118.0.h, 118.0.h),
                    pinLeft: true,
                    pinRight: true,
                    fixedHeight: true,
                    child: SvgPicture.string(
                      '<svg viewBox="481.6 931.0 118.0 118.0" ><defs><filter id="shadow"><feDropShadow dx="0" dy="24" stdDeviation="24"/></filter><linearGradient id="gradient" x1="0.047485" y1="0.5" x2="1.0" y2="0.5"><stop offset="0.0" stop-color="#ffb190fc"  /><stop offset="0.546798" stop-color="#ff7b75fd"  /><stop offset="1.0" stop-color="#ff5648fa"  /></linearGradient></defs><path transform="translate(98.0, 931.0)" d="M 442.578125 0 L 442.578125 0 C 475.1629028320313 0 501.578125 26.41519927978516 501.578125 59 C 501.578125 91.58480072021484 475.1629028320313 118 442.578125 118 L 442.578125 118 C 409.9933166503906 118 383.578125 91.58480072021484 383.578125 59 C 383.578125 26.41519927978516 409.9933166503906 0 442.578125 0 Z" fill="url(#gradient)" fill-opacity="1.0" stroke="none" stroke-width="1" stroke-opacity="1.0" stroke-miterlimit="4" stroke-linecap="butt" filter="url(#shadow)"/></svg>',
                      allowDrawingOutsideViewBox: true,
                      fit: BoxFit.fill,
                    ),
                  ),
                ],
              ),
            ),
          ],
        ),
      );

  static Widget iconLoading() => SizedBox(
        height: 59.64.h,
        child: SvgPicture.string(
          '<svg viewBox="513.4 850.5 53.2 61.4" ><path transform="matrix(0.999391, -0.034899, 0.034899, 0.999391, 60.57, 706.98)" d="M 491.0483703613281 195.0813293457031 C 491.0483703613281 204.9990234375 482.9786682128906 213.0687255859375 473.0610046386719 213.0687255859375 C 463.1433410644531 213.0687255859375 455.0736389160156 204.9990234375 455.0736389160156 195.0813293457031 C 455.0736389160156 185.1636657714844 463.1433410644531 177.0939636230469 473.0610046386719 177.0939636230469 L 473.0610046386719 185.6143188476563 L 491.4800720214844 173.3071594238281 L 473.0610046386719 161 L 473.0610046386719 169.5203552246094 C 458.9664611816406 169.5203552246094 447.5000305175781 180.98681640625 447.5000305175781 195.0813293457031 C 447.5000305175781 209.1758728027344 458.9664611816406 220.642333984375 473.0610046386719 220.642333984375 C 487.1555480957031 220.642333984375 498.6219787597656 209.1758728027344 498.6219787597656 195.0813293457031 L 491.0483703613281 195.0813293457031 Z" fill="#000000" stroke="none" stroke-width="1" stroke-miterlimit="10" stroke-linecap="butt" /></svg>',
          allowDrawingOutsideViewBox: true,
          fit: BoxFit.fitHeight,
        ),
      );
}
