import 'dart:async';
import 'package:minilikewallet/library/configuration_service.dart';
import 'package:shared_preferences/shared_preferences.dart';

abstract class GetMnemonic {
  Future<String> getMnemonic();
  Future<String> getETHPK();
}

class MnemonicRetrieve implements GetMnemonic {
  IConfigurationService configETH;

  String mnemonic;
  String pketh;
  @override
  Future<String> getMnemonic() async {
    SharedPreferences pref = await SharedPreferences.getInstance();
    configETH = new ConfigurationService(pref);
//    mnemonic = pref.getString('seed');
//    pketh = pref.getString('pk');
    mnemonic = await configETH.getMnemonic();
    pketh = configETH.getPrivateKey();
//    print(mnemonic);
//    print(pketh);
    return mnemonic + ':' + pketh;
  }

  Future<String> getETHPK() async {
    SharedPreferences pref = await SharedPreferences.getInstance();
    configETH = new ConfigurationService(pref);
//    pketh = pref.getString('pk');
    pketh = configETH.getPrivateKey();
    return pketh;
  }
}
