import 'dart:async';
import 'package:flutter/material.dart';
import 'package:minilikewallet/provider/home_provider/otp_provider/otp_provider.dart';
import 'package:minilikewallet/provider/home_provider/loading_provider/loading_provider.dart';
import 'package:minilikewallet/provider/home_provider/index_provider/index_provider.dart';
import 'package:minilikewallet/provider/home_provider/home_provider.dart';
import 'package:minilikewallet/theme/widget.dart';
import 'package:provider/provider.dart';

abstract class CheckLogin {
  checkLogin({String phone, BuildContext context});
}

class ICheckLogin implements CheckLogin {
  bool login = false;
  OTPProvider _otpProvider;
  HomeProvider _homeProvider;
  IndexProvider _indexProvider;
  LoadingProvider _loadingProvider;

  @override
  checkLogin({String phone, BuildContext context}) async {
    _homeProvider = Provider.of<HomeProvider>(context);
    _otpProvider = Provider.of<OTPProvider>(context);
    _loadingProvider = Provider.of<LoadingProvider>(context);
    _indexProvider = Provider.of<IndexProvider>(context);

    bool login = await _otpProvider.checkLogin();
    _loadingProvider.setStatus(status: true);
    if (login) {
      _homeProvider.setMenu(status: true);
      await _indexProvider.loadBalance();
      _loadingProvider.setStatus(status: false);
    } else {
      _homeProvider.setOTP(status: true);
      await _otpProvider.setNumberPhone(phone: phone);
      final res = await _otpProvider.checkExistUser(
          phoneNumber: _otpProvider.getNumberPhone);
      if (res) {
        final res = await _otpProvider.sendCodeToPhoneNumber(
            phoneNumber: _otpProvider.getNumberPhone);
        if (res) {
          _loadingProvider.setStatus(status: false);
        } else {
          _homeProvider.setOTP(status: false);
          WidgetTheme.showShortToastRed('เกิดข้อผิดพลาด');
        }
      } else {
        WidgetTheme.showShortToastRed('ไม่พบเบอร์ในระบบ');
      }
    }
  }
}
