import 'package:flutter/material.dart';
import 'package:minilikewallet/library/ethcontract.dart';

class LockAllProvider with ChangeNotifier {
  String _loading = 'ACTION_CONFIRM';
  AnimationController controller;

  LockAllProvider();

  String get getLoading => _loading;
  AnimationController get getController => controller;

  loadStatus({String status}) {
    _loading = status;
    notifyListeners();
  }

  setAnimationController({AnimationController control}) {
    controller = control;
    notifyListeners();
  }

  //Lock Like
  Future<String> lockLikePoint(
      {EthContract eth, String getPK, totalLock}) async {
    try {
      final transaction = await eth.lockLikePoint(pk: getPK, value: totalLock);
      List<String> tx = transaction.split(":");
      //transaction approve ขอสิทธิ์
      String approveTx = tx[0];
      //transaction Lock เหรียญ
      String lockTx = tx[1];
      print('approve tx : $approveTx');
      print('lock tx : $lockTx');
      return lockTx;
      //     .then((transaction) {
      //
      //   //delay 2 วิเพื่อให้ ธุรกรรมเสร็จก่อน เพราะ tomochain block time คือ 2 sec
      //   // new Future.delayed(new Duration(seconds: 4), () {});
      //
      // });

    } catch (e) {
      return 'false';
    }
  }
}
