import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:minilikewallet/home/button_action/button_action.dart';
import 'package:minilikewallet/library/configuration_service.dart';
import 'package:minilikewallet/provider/home_provider/home_provider.dart';
import 'package:minilikewallet/provider/home_provider/receive_provider/receive_provider.dart';
import 'package:minilikewallet/receive/component/receive_component.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:minilikewallet/theme/image.dart';
import 'package:minilikewallet/theme/widget.dart';
import 'package:provider/provider.dart';
import 'package:qr_flutter/qr_flutter.dart';
import 'package:shared_preferences/shared_preferences.dart';

class ReceiveScreen extends StatefulWidget {
  @override
  _ReceiveScreen createState() => _ReceiveScreen();
}

class _ReceiveScreen extends State<ReceiveScreen> {
  String dataString = '0x4b7513498777c01cd83d337dc66a83acbaf5aece';
  GlobalKey globalKey = new GlobalKey();
  HomeProvider _getLikeWallet;
  ReceiveProvider _receiveProvider;

  @override
  void didChangeDependencies() async {
    super.didChangeDependencies();
    _getLikeWallet = Provider.of<HomeProvider>(context);
    _receiveProvider = Provider.of<ReceiveProvider>(context);
    if (_receiveProvider.getAddress == '') {
      _receiveProvider.getIAddress();
      print("asdasd" + _receiveProvider.getAddress);
    }
  }

  @override
  void initState() {
    // TODO: implement initState
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    // TODO: implement build
    return Container(
      height: 1200.26.h,
      width: 1080.w,
      child: Stack(children: [
        ReceiveComponent.receiveBackground(),
        Column(
          children: [
            SizedBox(height: 213.h),
            InkWell(
              onTap: () {
                Clipboard.setData(
                        new ClipboardData(text: _receiveProvider.getAddress))
                    .then((d) {
                  WidgetTheme.showShortToastGrey('Copied address');
                });
              },
              child: new Container(
                alignment: Alignment.center,
                margin: EdgeInsets.only(),
                width: 600.w,
                child: new Text(
                  _receiveProvider.getAddress,
                  style: TextStyle(
                      color: Color(0xff707071),
                      fontFamily: 'Proxima Nova Light',
                      fontWeight: FontWeight.normal,
                      letterSpacing: 1.5,
                      fontSize: 39.h),
                  textAlign: TextAlign.center,
                ),
              ),
            ),
            SizedBox(height: 38.h),
            Center(
              child: RepaintBoundary(
                  key: globalKey,
                  child: Container(
                      child:
                          Stack(alignment: Alignment(0, 0), children: <Widget>[
                    Container(
                      height: 600.h,
                      width: 600.h,
                      decoration: BoxDecoration(
                        color: Colors.white,
                        boxShadow: [
                          BoxShadow(
                            color: Colors.black.withOpacity(0.16),
                            offset: Offset(0, 5),
                            blurRadius: 12,
                          ),
                        ],
                      ),
                    ),
                    Container(
                      height: 600.h,
                      width: 600.h,
                      child: QrImage(
                        data: _receiveProvider.getAddress,
                        size: 530.h,
                        embeddedImage: AssetImage(ImageTheme.iconLike,
                            package: 'minilikewallet'),
                        embeddedImageStyle: QrEmbeddedImageStyle(
                          size: Size(
                            100.6.h,
                            100.6.h,
                          ),
                        ),
                        errorCorrectionLevel: QrErrorCorrectLevel.Q,
                        gapless: false,
                        version: 9,
                      ),
                    ),
                  ]))),
            ),
            Expanded(child: Container()),
            FlatButton(
                onPressed: () async {
                  _getLikeWallet.setMenu(status: true);
                  _getLikeWallet.setReceive(status: false);
                },
                child: Container(
                    height: 30.h,
                    width: 60.w,
                    padding: EdgeInsets.symmetric(vertical: 10.h),
                    child: ButtonAction.closeMenuWhite())),
            // SizedBox(height: 41.h),
          ],
        ),
      ]),
    );
  }
}
