import 'dart:async';
import 'dart:convert' as convert;
import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:minilikewallet/model/vending.dart';
import 'package:minilikewallet/theme/widget.dart';
import 'package:qr_code_scanner/qr_code_scanner.dart';

class ScanQrCode extends StatefulWidget {
  @override
  _ScanQrCode createState() => new _ScanQrCode();
}

class _ScanQrCode extends State<ScanQrCode> {
  String qr;
  GlobalKey key = new GlobalKey();

  bool _isLoad = false;
  QRViewController controller;
  final GlobalKey qrKey = GlobalKey(debugLabel: 'QR');
  int count = 0;

  @override
  initState() {
    super.initState();
  }

  @override
  void dispose() {
    controller.dispose();
    super.dispose();
  }

  DateTime now = new DateTime.now();

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      backgroundColor: Color(0xff141322),
      key: key,
      body: Container(
        // color: DiGiBathAppTheme.background,
        child: new Center(
          child: new Column(
            mainAxisAlignment: MainAxisAlignment.start,
            children: <Widget>[
              SizedBox(height: 140.h),
              buttonBack(),
              SizedBox(height: 50.h),
              Container(
                /// Camera for Scan Barcode
                margin: EdgeInsets.only(top: 0.h, bottom: 50.h),
                child: Center(
                  child: SizedBox(
                    width: MediaQuery.of(context).size.width,
                    height: 950.h,
                    child: QRView(
                      key: qrKey,
                      onQRViewCreated: _onQRViewCreated,
                    ),
                  ),
                ),
              ),
            ],
          ),
        ),
      ),
    );
  }

  Widget buttonBack() => Align(
        alignment: Alignment.centerLeft,
        child: InkWell(
            onTap: () => Navigator.of(context).pop(),
            child: Padding(
                padding: EdgeInsets.all(50.w),
                child: WidgetTheme.backButton())),
      );

  void _onQRViewCreated(QRViewController controller) async {
    this.controller = controller;
    controller.scannedDataStream.listen((scanData) async {
      controller.pauseCamera();
      try {
        if (!mounted) return;
        print(scanData);
        if (scanData.substring(0, 2) == '0x') {
          controller.pauseCamera();
          Navigator.of(context).pop(scanData);
        } else {
          // controller.pauseCamera();
          // print('else vending');
          // Vending vending = Vending.fromJson(jsonDecode(scanData));
          // print(vending);
          // if (vending.function == 'transfer_vending') {
          //   controller.pauseCamera();
          //   Navigator.pushReplacement(
          //     context,
          //     MaterialPageRoute(
          //         builder: (context) => confirmTransection(
          //             titleName: vending.addr,
          //             addressText: vending.addr,
          //             amountSend: vending.amount.toString(),
          //             rateCurrency: 1,
          //             vending: vending,
          //             isVending: true,
          //             contract: 'no',
          //             abi: 'no',
          //             callFunction: 'no')),
          //     // ModalRoute.withName('/confirmTransection'),
          //   );
          // }
        }
      } catch (e) {
        print(e);
        setState(() {
          // _isLoad = false;
        });
      }
    });
  }
}
