import 'package:adobe_xd/adobe_xd.dart';
import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:flutter_svg/flutter_svg.dart';
import 'package:minilikewallet/theme/image.dart';

class SendReceiptComponent {
  SendReceiptComponent._();
  static Widget receiptBackground() => Container(
        height: 2119.h,
        width: 1080.w,
        decoration: BoxDecoration(
          borderRadius: BorderRadius.circular(103.0.h),
          gradient: LinearGradient(
            begin: Alignment(0.0, 1.0),
            end: Alignment(0.0, -1.0),
            colors: [const Color(0xff242c49), const Color(0xff191932)],
            stops: [0.0, 1.0],
          ),
          // boxShadow: [
          //   BoxShadow(
          //     color: const Color(0x59000000),
          //     offset: Offset(0, 19),
          //     blurRadius: 45,
          //   ),
          // ],
        ),
      );

  static Widget imageReceipt() => Image.asset(
        ImageTheme.receipt,
        height: 1443.h,
        width: 961.w,
        fit: BoxFit.fitHeight,
        package: 'minilikewallet',
      );

  static Widget title({String text}) => Text(
        '$text',
        style: TextStyle(
          fontFamily: 'Prompt',
          fontSize: 36.h,
          color: const Color(0xff000000),
          letterSpacing: 1.08,
          height: 1.6388888888888888,
        ),
        textHeightBehavior: TextHeightBehavior(applyHeightToFirstAscent: false),
        textAlign: TextAlign.left,
      );

  static Widget detail({String text}) => Text(
        '$text',
        style: TextStyle(
          fontFamily: 'Prompt',
          fontSize: 50.h,
          color: const Color(0xffffffff),
          letterSpacing: 1.5,
          height: 1.2,
          shadows: [
            Shadow(
              color: const Color(0xff24cfe2),
              offset: Offset(0, 6),
              blurRadius: 12,
            )
          ],
        ),
        textHeightBehavior: TextHeightBehavior(applyHeightToFirstAscent: false),
        textAlign: TextAlign.left,
      );
  static Widget textNote({String text}) => Text(
        '$text',
        style: TextStyle(
          fontFamily: 'Prompt',
          fontSize: 36.h,
          color: const Color(0xffffffff),
          letterSpacing: 1.5,
          height: 1.2,
          shadows: [
            Shadow(
              color: const Color(0xff24cfe2),
              offset: Offset(0, 6),
              blurRadius: 12,
            )
          ],
        ),
        overflow: TextOverflow.ellipsis,
        maxLines: 3,
        textHeightBehavior: TextHeightBehavior(applyHeightToFirstAscent: false),
        textAlign: TextAlign.left,
      );
  static Widget textBack31({String text}) => Text(
        '$text',
        style: TextStyle(
          fontFamily: 'Prompt',
          fontSize: 31.h,
          color: const Color(0xff000000),
          letterSpacing: 0.9299999999999999,
          height: 1.5161290322580645,
        ),
        textHeightBehavior: TextHeightBehavior(applyHeightToFirstAscent: false),
        textAlign: TextAlign.left,
      );
  static Widget buttonShare() => SizedBox(
        // width: 405.0.w,
        height: 111.0.h,
        child: Stack(
          children: <Widget>[
            Container(
              width: 405.0.w,
              height: 80.0.h,
              child: Stack(
                alignment: Alignment.center,
                children: <Widget>[
                  SvgPicture.string(
                    '<svg viewBox="114.0 1665.0 405.0 80.0" ><defs><linearGradient id="gradient" x1="0.0" y1="0.5" x2="1.0" y2="0.5"><stop offset="0.0" stop-color="#ff00ced3"  /><stop offset="1.0" stop-color="#5500ced3" stop-opacity="0.33" /></linearGradient></defs><path transform="translate(114.0, 1665.0)" d="M 40 0 L 365 0 C 387.0914001464844 0 405 17.90860939025879 405 40 C 405 62.09139251708984 387.0914001464844 80 365 80 L 40 80 C 17.90860939025879 80 0 62.09139251708984 0 40 C 0 17.90860939025879 17.90860939025879 0 40 0 Z" fill="url(#gradient)" fill-opacity="0.15" stroke="none" stroke-width="2" stroke-opacity="0.15" stroke-miterlimit="4" stroke-linecap="butt" /></svg>',
                    allowDrawingOutsideViewBox: true,
                    fit: BoxFit.fill,
                    height: 80.h,
                  ),
                  Text(
                    'Share',
                    style: TextStyle(
                      fontFamily: 'Proxima Nova',
                      fontSize: 33.h,
                      color: const Color(0xff08eef3),
                      letterSpacing: 1.6500000000000001,
                      shadows: [
                        Shadow(
                          color: const Color(0x29000000),
                          offset: Offset(0, 3),
                          blurRadius: 6,
                        )
                      ],
                    ),
                    textAlign: TextAlign.center,
                  ),
                ],
              ),
            ),
            Positioned(
              bottom: 0,
              left: 62.w,
              child: Image.asset(
                ImageTheme.iconShare,
                height: 76.h,
                package: 'minilikewallet',
              ),
            ),
          ],
        ),
      );
  static Widget buttonSave() => SizedBox(
        // width: 405.0.w,
        height: 111.0.h,
        child: Stack(
          children: <Widget>[
            Container(
              width: 405.0.w,
              height: 80.0.h,
              child: Stack(
                alignment: Alignment.center,
                children: <Widget>[
                  SvgPicture.string(
                    '<svg viewBox="114.0 1665.0 405.0 80.0" ><defs><linearGradient id="gradient" x1="0.0" y1="0.5" x2="1.0" y2="0.5"><stop offset="0.0" stop-color="#ff00ced3"  /><stop offset="1.0" stop-color="#5500ced3" stop-opacity="0.33" /></linearGradient></defs><path transform="translate(114.0, 1665.0)" d="M 40 0 L 365 0 C 387.0914001464844 0 405 17.90860939025879 405 40 C 405 62.09139251708984 387.0914001464844 80 365 80 L 40 80 C 17.90860939025879 80 0 62.09139251708984 0 40 C 0 17.90860939025879 17.90860939025879 0 40 0 Z" fill="url(#gradient)" fill-opacity="0.15" stroke="none" stroke-width="2" stroke-opacity="0.15" stroke-miterlimit="4" stroke-linecap="butt" /></svg>',
                    allowDrawingOutsideViewBox: true,
                    fit: BoxFit.fitHeight,
                    width: 405.0.w,
                    height: 80.h,
                  ),
                  Text(
                    'Save',
                    style: TextStyle(
                      fontFamily: 'Proxima Nova',
                      fontSize: 33.h,
                      color: const Color(0xff08eef3),
                      letterSpacing: 1.6500000000000001,
                      shadows: [
                        Shadow(
                          color: const Color(0x29000000),
                          offset: Offset(0, 3),
                          blurRadius: 6,
                        )
                      ],
                    ),
                    textAlign: TextAlign.center,
                  ),
                ],
              ),
            ),
            Positioned(
              bottom: 0,
              left: 62.w,
              child: Image.asset(
                ImageTheme.iconSave,
                height: 76.h,
                package: 'minilikewallet',
              ),
            ),
          ],
        ),
      );
  static Widget line() => Image.asset(
        ImageTheme.line,
        height: 1197.15.h,
        package: 'minilikewallet',
      );
}
