import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:flutter_spinkit/flutter_spinkit.dart';
import 'dart:math';

import 'package:loading_indicator/loading_indicator.dart';
import 'package:minilikewallet/model/contact.dart';
// import 'package:flutter_spinkit/flutter_spinkit.dart';
// import 'package:likewallet/screen_util.dart';
//
// import 'package:loading_indicator/loading_indicator.dart';

class CustomLoading extends StatefulWidget {
  // ignore: prefer_const_constructors_in_immutables
  CustomLoading({
    Key key,
    this.color = Colors.cyan,
    this.size = 50.0,
    this.itemBuilder,
    this.duration = const Duration(milliseconds: 1200),
    this.controller,
  })  : assert(
            !(itemBuilder is IndexedWidgetBuilder && color is Color) &&
                !(itemBuilder == null && color == null),
            'You should specify either a itemBuilder or a color'),
        assert(size != null),
        super(key: key);

  final Color color;
  final double size;
  final IndexedWidgetBuilder itemBuilder;
  final Duration duration;
  final AnimationController controller;

  @override
  _SpinKitFadingCircleState createState() => _SpinKitFadingCircleState();
}

class _SpinKitFadingCircleState extends State<CustomLoading>
    with SingleTickerProviderStateMixin {
  AnimationController _controller;

  @override
  void initState() {
    super.initState();
//    _controller = (widget.controller ??
//        AnimationController(vsync: this, duration: widget.duration))
//      ..repeat();

    _controller = AnimationController(
      duration: const Duration(seconds: 10),
      vsync: this,
    )..repeat();
  }

  @override
  void dispose() {
    _controller.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return WillPopScope(
      onWillPop: () {},
      child: Center(
        child: Column(
          mainAxisAlignment: MainAxisAlignment.center,
          children: <Widget>[
            Stack(
              children: <Widget>[
                Center(
                  child: SizedBox(
                    width: 600.w,
                    child: LoadingIndicator(
                      color: Color(0xFF29D8DA).withOpacity(1),
                      indicatorType: Indicator.ballClipRotate,
                    ),
                  ),
                ),
              ],
            ),
          ],
        ),
      ),
    );

//    return Center(
//      child: SizedBox.fromSize(
//        size: Size.square(widget.size),
//        child: Stack(
//          children: [
//            _circle(1, .0),
//            _circle(2, -1.1),
//            _circle(3, -1.0),
//            _circle(4, -0.9),
//            _circle(5, -0.8),
//            _circle(6, -0.7),
//            _circle(7, -0.6),
//            _circle(8, -0.5),
//            _circle(9, -0.4),
//            _circle(10, -0.3),
//            _circle(11, -0.2),
//            _circle(12, -0.1),
//          ],
//        ),
//      ),
//    );
  }
}

class CustomLoadingText extends StatefulWidget {
  // ignore: prefer_const_constructors_in_immutables
  CustomLoadingText({
    Key key,
    this.color = Colors.cyan,
    this.size = 50.0,
    this.itemBuilder,
    this.duration = const Duration(milliseconds: 1200),
    this.controller,
  })  : assert(
            !(itemBuilder is IndexedWidgetBuilder && color is Color) &&
                !(itemBuilder == null && color == null),
            'You should specify either a itemBuilder or a color'),
        assert(size != null),
        super(key: key);

  final Color color;
  final double size;
  final IndexedWidgetBuilder itemBuilder;
  final Duration duration;
  final AnimationController controller;

  @override
  _SpinKitFadingCircleTextState createState() =>
      _SpinKitFadingCircleTextState();
}

class _SpinKitFadingCircleTextState extends State<CustomLoadingText>
    with SingleTickerProviderStateMixin {
  AnimationController _controller;

  @override
  void initState() {
    super.initState();

    _controller = AnimationController(
      duration: const Duration(seconds: 10),
      vsync: this,
    )..repeat();
  }

  @override
  void dispose() {
    _controller.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return WillPopScope(
      onWillPop: () {},
      child: Scaffold(
        backgroundColor: Colors.black.withOpacity(0.5),
        body: Center(
          child: Column(
            mainAxisAlignment: MainAxisAlignment.center,
            children: <Widget>[
              Stack(
                children: <Widget>[
                  Container(
                    height: 600.h,
                    width: 800.w,
                    decoration: BoxDecoration(
                      borderRadius: BorderRadius.all(
                        Radius.circular(20.0),
                      ),
                      color: Color(0xff08eef3).withOpacity(0.9),
                    ),
                    child: Column(children: <Widget>[
                      SizedBox(
                          height: 400.h,
                          child: SpinKitRing(
                            color: Colors.black,
                            size: 300.h,
                          )),
                      SizedBox(
                        height: 20.h,
                      ),
                      Text(
                        'กรุณารอสักครู่...\n กำลังตรวจสอบรายการ',
                        textAlign: TextAlign.center,
                        style: TextStyle(
                          color: Colors.black,
                          fontWeight: FontWeight.bold,
                          fontSize: 45.h,
                        ),
                      )
                    ]),
                  ),
                ],
              ),
            ],
          ),
        ),
      ),
    );

//    return Center(
//      child: SizedBox.fromSize(
//        size: Size.square(widget.size),
//        child: Stack(
//          children: [
//            _circle(1, .0),
//            _circle(2, -1.1),
//            _circle(3, -1.0),
//            _circle(4, -0.9),
//            _circle(5, -0.8),
//            _circle(6, -0.7),
//            _circle(7, -0.6),
//            _circle(8, -0.5),
//            _circle(9, -0.4),
//            _circle(10, -0.3),
//            _circle(11, -0.2),
//            _circle(12, -0.1),
//          ],
//        ),
//      ),
//    );
  }
}
